Motivated by:

http://www.pgcon.org/2018/schedule/events/1204.en.html

but implemented as small Postgres extension using native WAL traverse methods and posix_fadvise -
just 100 lines of code.

My experiments shows that at standard desktop:
1. Prefetch at HDD doesn't give any positive effect.
2. Using posix_fadvise allows to speed-up random read speed at SSD up to 2 times.
3. posix_fadvise(WILLNEED) is more efficient than perform normal reads.
4. Calling posix_fadvise in more than one thread has no sense.

Usage:
1. At master: create extension wal_prefetch
2. At replica: Call pg_wal_prefetch() function: it will not return until you interrupt it.

pg_wal_prefetch function will infinitely traverse WAL and prefetch block references in WAL records
using posix_fadvise(WILLNEED) system call.

It is possible to explicitly specify start LSN for pg_wal_prefetch() function. Otherwise, WAL redo position will be used as start LSN.
